-- Test order_amenity_carousel
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(11);

set search_path to camper, public;

select has_function('camper', 'order_amenity_carousel', array['text', 'integer', 'integer[]']);
select function_lang_is('camper', 'order_amenity_carousel', array['text', 'integer', 'integer[]'], 'sql');
select function_returns('camper', 'order_amenity_carousel', array['text', 'integer', 'integer[]'], 'void');
select isnt_definer('camper', 'order_amenity_carousel', array['text', 'integer', 'integer[]']);
select volatility_is('camper', 'order_amenity_carousel', array['text', 'integer', 'integer[]'], 'volatile');
select function_privs_are('camper', 'order_amenity_carousel', array ['text', 'integer', 'integer[]'], 'guest', array[]::text[]);
select function_privs_are('camper', 'order_amenity_carousel', array ['text', 'integer', 'integer[]'], 'employee', array[]::text[]);
select function_privs_are('camper', 'order_amenity_carousel', array ['text', 'integer', 'integer[]'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'order_amenity_carousel', array ['text', 'integer', 'integer[]'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate amenity_carousel cascade;
truncate amenity cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 'ES', 'EUR', 'ca')
     , (2, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ff00ff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffff00","a"};')
     , ('text/plain', 'hello, world!')
     , ('image/svg+xml', '<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>')
;

insert into media (media_id, company_id, original_filename, content_hash)
values ( 3, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , ( 4, 1, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff00ff","a"};'))
     , ( 5, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffff00","a"};'))
     , ( 6, 1, 'text.txt', sha256('hello, world!'))
     , ( 7, 1, 'image.svg', sha256('<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>'))
     , ( 8, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , ( 9, 1, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff00ff","a"};'))
     , (10, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffff00","a"};'))
     , (11, 1, 'text.txt', sha256('hello, world!'))
     , (12, 1, 'image.svg', sha256('<svg xmlns="http://www.w3.org/2000/svg" width="1" height="1"/>'))
;

insert into amenity (amenity_id, company_id, label, name)
values (15, 1, 'A1', 'Amenity A1')
     , (16, 2, 'A1', 'Amenity A1')
;

insert into amenity_carousel (amenity_id, media_id, caption)
values (15,  3, '1')
     , (15,  4, '2')
     , (15,  5, '3')
     , (15,  6, '4')
     , (15,  7, '5')
     , (16,  8, '1')
     , (16,  9, '2')
     , (16, 10, '3')
     , (16, 11, '4')
     , (16, 12, '5')
;

select lives_ok(
	$$ select order_amenity_carousel('A1', 1, '{5,7,6,3,4}') $$,
	'Should be able to sort amenity type slides using their media ID'
);

select bag_eq(
	$$ select amenity_id, media_id, position from amenity_carousel $$,
	$$ values (15,  5, 1)
	        , (15,  7, 2)
	        , (15,  6, 3)
	        , (15,  3, 4)
	        , (15,  4, 5)
	        , (16,  8, 2147483647)
	        , (16,  9, 2147483647)
	        , (16, 10, 2147483647)
	        , (16, 11, 2147483647)
	        , (16, 12, 2147483647)
	$$,
	'Should have sorted all amenity type slides.'
);


select *
from finish();

rollback;
